searchNodes=[{"ref":"Error.html","title":"Error","type":"module","doc":"Model domain and infrastructure errors as regular data."},{"ref":"Error.html#caused_by/1","title":"Error.caused_by/1","type":"function","doc":"Extract the cause of an error (of type Error.t()). Think of this as inspecting deeper into the stack trace."},{"ref":"Error.html#details/1","title":"Error.details/1","type":"function","doc":"Return the map of detailed information supplied at Error creation."},{"ref":"Error.html#domain/2","title":"Error.domain/2","type":"function","doc":"Create a domain error, with a reason and optional details."},{"ref":"Error.html#infra/2","title":"Error.infra/2","type":"function","doc":"Create an infra error, with a reason and optional details."},{"ref":"Error.html#kind/1","title":"Error.kind/1","type":"function","doc":"Determine whether a given Error is a domain or infra error."},{"ref":"Error.html#map_details/2","title":"Error.map_details/2","type":"function","doc":"Map a function on the details map in an Error. Useful for adding extra details, modifying exisint ones, or removing them."},{"ref":"Error.html#reason/1","title":"Error.reason/1","type":"function","doc":"Return the reason the Error was created with."},{"ref":"Error.html#to_map/1","title":"Error.to_map/1","type":"function","doc":"Convert an Error to an Elixir map."},{"ref":"Error.html#wrap/2","title":"Error.wrap/2","type":"function","doc":"Wrap a higher-level error &#39;on top&#39; of a lower-level error. Think of this as a stack trace, but in domain-model terms."},{"ref":"Error.html#t:domain/0","title":"Error.domain/0","type":"opaque","doc":""},{"ref":"Error.html#t:domain/1","title":"Error.domain/1","type":"opaque","doc":""},{"ref":"Error.html#t:infra/0","title":"Error.infra/0","type":"opaque","doc":""},{"ref":"Error.html#t:infra/1","title":"Error.infra/1","type":"opaque","doc":""},{"ref":"Error.html#t:kind/0","title":"Error.kind/0","type":"type","doc":""},{"ref":"Error.html#t:reason/0","title":"Error.reason/0","type":"type","doc":""},{"ref":"Error.html#t:t/0","title":"Error.t/0","type":"opaque","doc":""},{"ref":"Error.html#t:t/1","title":"Error.t/1","type":"opaque","doc":""},{"ref":"readme.html","title":"Error","type":"extras","doc":"Error Errors modeled as data."},{"ref":"readme.html#installation","title":"Error - Installation","type":"extras","doc":"def deps do [ {:error, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#creation","title":"Error - Creation","type":"extras","doc":"Errors come in two kinds: :domain errors, which are part of your business model, or Domain in DDD parlance. You can use the map in the second argument position to supply whatever extra details you find useful: Error.domain(:invalid_username, %{ provided_username: &quot;alex&quot;, unmet_requirement: &quot;Must start with capital letter&quot;} }) :infra errors, which represent failures of the infrastructure or computation substrate. Similarly, you can supply a map as the second argument, with arbitrary details of your choosing. Error.infra(:db_down, %{retried_count: 5})"},{"ref":"readme.html#usage","title":"Error - Usage","type":"extras","doc":"Errors should be created at the place where they occur. Domain errors can be later converted to user-facing messages, in the presentation logic. Infra errors, on the other hand, most often translate to a &quot;500 error&quot; and the only piece of information that an end-user needs to know is that &quot;Something went wrong&quot;. At the same time, you want to log these errors extensively so that you can investigate the issue later. Errors provide a convenient to_map function, so that your view logic doesn&#39;t need to know about the Error type."}]